#include <stdio.h>
#include <math.h>
#include <errno.h>

#include "DEFS.h"
#include "VEC.h"

void MatrixVectorMultiply(REAL *u, REAL **matrix, REAL *v, int NumRates)
{
  int i,j;
  for(i=1;i<=NumRates; i++) {
    *(u+i) = 0.0;
    for(j=1;j<=NumRates; j++) {
      *(u+i) += (*(matrix[i] + j))*(*(v+j));
     }
  }
}
void SetVector(REAL *u,REAL *v,int NumRates)
{
 int i;
 for(i=1;i<=NumRates;i++) u[i]=v[i];
}

void ArrayMultiply(REAL *u, REAL *v, int NumRates)
{
 int i;
 for(i=1;i<=NumRates;i++) u[i] *= v[i];
}

void SqRoot(REAL *u, int NumRates)
{
 int i;
 for(i=1;i<=NumRates;i++) u[i] = exp(0.5*log(u[i]));
}


void VectorAdd(REAL *u, REAL *v, int NumRates)
{
 int i;
 for(i=1;i<=NumRates;i++) u[i] += v[i];
}
